Attribute VB_Name = "Ties"
Option Explicit

' tie structure, used to represent robot ties
Public Type tie
  Port As Integer         ' the tie port, i.e. the value one must give to .tienum var to access the tie
  pnt As Integer          ' the robot the tie points to
  ptt As Byte             ' the back tie of the pointed robot
  ang As Single           ' current tie angle (relative to aim)
  bend As Single          ' angle bend value
  angreg As Boolean       ' the angle is fixed?
  ln As Long              ' tie len
  shrink As Long          ' tie shrink value
  stat As Boolean
  last As Integer         ' tie timing: <-1: cycles to angle fixing; >1: cycles to tie destruction
  mem As Integer          ' Reads nrg of tied robot
  'tienrg As Integer
  back As Boolean         ' is it a back tie?
  nrgused As Boolean      ' for colouring the tie red in case of energy transfer
  infused As Boolean      ' for colouring white in case of information transfer
  sharing As Boolean       ' for coloring yellow in case of sharing
End Type

'old tie structure, for compatibility purposes
Public Type tie2
  Port As Integer         ' the tie port, i.e. the value one must give to .tienum var to access the tie
  pnt As Integer          ' the robot the tie points to
  ptt As Byte             ' the back tie of the pointed robot
  ang As Single           ' current tie angle (relative to aim)
  bend As Single          ' angle bend value
  angreg As Boolean       ' the angle is fixed?
  ln As Long              ' tie len
  shrink As Long          ' tie shrink value
  stat As Boolean
  last As Integer         ' tie timing: <-1: cycles to angle fixing; >1: cycles to tie destruction
  mem As Integer          ' Reads nrg of tied robot
  back As Boolean         ' is it a back tie?
  nrgused As Boolean      ' for colouring the tie red in case of energy transfer
  infused As Boolean      ' for colouring white in case of information transfer
End Type

'This routine deals with information transfer only. Added in to fix a major bug
'in which older robots could transfer information to younger bots OK but
'young bots could not transfer information to older bots in time for the information
'to do any good
Public Sub tieportcom(t As Integer)
  Dim k As Integer
  Dim tn As Integer
  'Dim tp As Integer
  'tp = tieport1
  
  With rob(t)
    tn = .mem(tienum)
    k = 1
      If .mem(tieloc) > 0 And .mem(tieloc) < 1001 Then  '.tieloc value
        While .Ties(k).pnt > 0
          If .Ties(k).Port = tn Then
            rob(.Ties(k).pnt).mem(.mem(tieloc)) = .mem(tieval) 'stores a value in tied robot memory location (.tieloc) specified in .tieval
            If Not .Ties(k).back Then   'forward information transfer
              .Ties(k).infused = True   'draws tie white
            Else                        'backward information transfer
              rob(.Ties(k).pnt).Ties(.Ties(k).ptt).infused = True 'draws tie white
            End If
            .mem(tienum) = 0
            .mem(tieval) = 0
            .mem(tieloc) = 0
          End If
          k = k + 1
        Wend
      End If
      
  End With
End Sub
' this procedure takes care of parsing and addressing
' ties commands: bend, shrink, communications
Public Sub Update_Ties(t As Integer)
  Dim tp As Integer
  Dim tn As Integer
  Dim k As Integer
  Dim l As Integer
  Dim ptag As Single
  tn = 1
  With rob(t)
    tp = tieport1
    tn = .mem(tp + 5)   '.tienum value
    'this routine addresses all ties. not just ones that match .tienum
    k = 1
    .vbody = .body
    While .Ties(k).pnt > 0  'while there is a tie that points to another robot. Can't share with a wall (I hope)
      If .Multibot And Not rob(.Ties(k).pnt).Wall Then
        If .mem(830) > 0 Then
          sharenrg t, k
          .Ties(k).sharing = True   'yellow ties
        End If
        If .mem(831) > 0 Then
          sharewaste t, k
          .Ties(k).sharing = True   'yellow ties
        End If
        If .mem(832) > 0 Then
          shareshell t, k
          .Ties(k).sharing = True   'yellow ties
        End If
        If .mem(833) > 0 Then
          shareslime t, k
          .Ties(k).sharing = True   'yellow ties
        End If
        .vbody = .vbody + rob(.Ties(k).pnt).body
      End If
      k = k + 1
    Wend
    .mem(tp + 4) = .Ties(k - 1).Port 'value stored in .tiepres. the tienum of the highest k number tie. Might be useful.
    .mem(830) = 0
    .mem(831) = 0
    .mem(832) = 0
    .mem(833) = 0
    .Numties = k - 1
    .mem(tp + 16) = .Numties   'places a value in the memory cell .numties for number of ties attached to a robot
    If .Numties = 0 Then .Multibot = False: .mem(470) = 0: Exit Sub
    
    If .mem(tp + 17) <> 0 Then
      k = 1
      While .Ties(k).pnt > 0     'deletes a tie specified in .deltie
        If .Ties(k).Port = .mem(tp + 17) Then
          deltie t, .Ties(k).pnt
        End If
      k = k + 1
      Wend
      .mem(tp + 17) = 0 'resets .deltie command
    End If
    If tn Then  'routines only carried out if .tienum has a value
      k = 1
      While .Ties(k).pnt > 0 And .Multibot = True
        If .mem(468) <> 32000 And .Ties(k).Port = tn Then   'fixes tie angle
          If .mem(468) > 628 Then .mem(468) = -627
          If .mem(468) < -628 Then .mem(468) = 627
          .Ties(k).ang = .mem(468) / 200
        End If
        If .mem(469) <> 0 And .Ties(k).Port = tn Then 'fixes tie length
          .Ties(k).ln = .mem(469) 'for first robot
          rob(.Ties(k).pnt).Ties(srctie((.Ties(k).pnt), t)).ln = .mem(469) 'for second robot. What a messed up formula
        End If
        k = k + 1
      Wend
      .mem(468) = 32000
      .mem(469) = 0
      k = 1
      If .mem(tp) Then  '.tieang value
        k = 1
        While .Ties(k).pnt > 0
          If .Ties(k).Port = tn Then bend t, k, .mem(tp) 'bend a tie
          k = k + 1
        Wend
      End If
      If .mem(tp + 1) Then  '.tielen value
        k = 1
        While .Ties(k).pnt > 0
          If .Ties(k).Port = tn Then shrink t, k, .mem(tp + 1) 'set tie length to value specified in mem location 451 (tp+1)
          k = k + 1
        Wend
      End If
      If .mem(tp + 2) < 0 And .mem(tp + 2) > -1001 Then  '.tieloc value
        If .mem(tp + 2) = -1 And .mem(tp + 3) <> 0 Then   'tieloc = -1 and .tieval not zero
          k = 1
          l = .mem(tp + 3)
          If l > 1000 Then l = 1000
          If l > .nrg Then l = .nrg
          If l < -3000 Then l = -3000
          While .Ties(k).pnt > 0     'tie actually points at something
            If .Ties(k).Port = tn And Not rob(.Ties(k).pnt).Wall Then    'try to stop robots killing walls with ties
              If l > 0 Then
                rob(.Ties(k).pnt).nrg = rob(.Ties(k).pnt).nrg + l * (70 / 100) 'tied robot receives energy
                rob(.Ties(k).pnt).body = rob(.Ties(k).pnt).body + l * (29 / 1000) 'tied robot stores some fat
                rob(.Ties(k).pnt).Waste = rob(.Ties(k).pnt).Waste + l * (1 / 100) 'tied robot receives waste
                If rob(.Ties(k).pnt).body > 32000 Then rob(.Ties(k).pnt).body = 32000
                rob(.Ties(k).pnt).Radius = rob(.Ties(k).pnt).body / factor
                .nrg = .nrg - l   'tying robot gives up energy
              End If
              If l < 0 Then
                If Abs(l) > .body / 10 Then l = .body / -5    'fixes maximum energy drain proportional to body
                If Abs(l) > rob(.Ties(k).pnt).nrg Then l = (rob(.Ties(k).pnt).nrg) * -1 'limits energy taken from tied robot
                ptag = Abs(l / 4)
                If rob(.Ties(k).pnt).poison > ptag Then 'target robot has poison
                  If rob(.Ties(k).pnt).fname <> .fname Then 'can't poison your brother
                    .Poisoned = True
                    .Poisoncount = .Poisoncount + ptag
                    If .Poisoncount > 32000 Then .Poisoncount = 32000
                    l = 0
                    rob(.Ties(k).pnt).poison = rob(.Ties(k).pnt).poison - ptag
                    rob(.Ties(k).pnt).mem(827) = rob(.Ties(k).pnt).poison
                    If rob(.Ties(k).pnt).mem(834) > 0 Then
                      .Ploc = rob(.Ties(k).pnt).mem(834)  'sets .Ploc to targets .mem(ploc)
                    Else
                      .Ploc = Int(Rnd * 1000) + 1
                    End If
                  End If
                End If
                rob(.Ties(k).pnt).nrg = rob(.Ties(k).pnt).nrg + l 'tied robot loses energy.
                If rob(.Ties(k).pnt).nrg = 0 Then rob(.Ties(k).pnt).nrg = -100 'ensures that robots with nrg = 0 actually die
                If rob(.Ties(k).pnt).nrg < 0 And rob(.Ties(k).pnt).Dead = False Then
                  rob(.Ties(k).pnt).Dead = True
                  .kills = .kills + 1
                  If .kills > 32000 Then .kills = 32000
                  .mem(220) = .kills
                End If
                .nrg = .nrg - l * (70 / 100) 'tying robot receives energy
                .body = .body - l * (29 / 1000) 'tying robot stores some fat
                If .body > 32000 Then .body = 32000
                .Radius = .body / factor
                .Waste = .Waste + Abs(l / 100) 'tying robot adds waste
              End If
              If Not .Ties(k).back Then   'forward ties
                .Ties(k).nrgused = True   'red ties
              Else                        'backward ties
                rob(.Ties(k).pnt).Ties(.Ties(k).ptt).nrgused = True 'red ties
              End If
            End If
            k = k + 1
          Wend
        End If
        If .mem(tp + 2) = -3 And .mem(tp + 3) <> 0 Then  'inject or steal venom
          If .mem(tp + 3) > 100 Then .mem(tp + 3) = 100
          If .mem(tp + 3) > .venom Then .mem(tp + 3) = .venom
          If .mem(tp + 3) < -100 Then .mem(tp + 3) = -100
          k = 1
          While .Ties(k).pnt > 0
            If .Ties(k).Port = tn Then
              'If .mem(tp + 3) < rob(.Ties(k).pnt).Venom Then .mem(tp + 3) = rob(.Ties(k).pnt).Venom
              If .mem(tp + 3) > 0 Then
                rob(.Ties(k).pnt).Paracount = rob(.Ties(k).pnt).Paracount + .mem(tp + 3) 'paralysis counter set
                rob(.Ties(k).pnt).Paralyzed = True         'robot paralyzed
                If .mem(835) > 0 Then
                  If .mem(835) > 999 Then .mem(835) = 999
                  rob(.Ties(k).pnt).Vloc = .mem(835)
                Else
                  rob(.Ties(k).pnt).Vloc = Int(Rnd * 1000) + 1
                End If
                rob(.Ties(k).pnt).Vval = .mem(836)
                .venom = .venom - .mem(tp + 3)
                .mem(825) = .venom
              Else
                rob(.Ties(k).pnt).venom = rob(.Ties(k).pnt).venom + .mem(tp + 3)
                .venom = .venom - .mem(tp + 3)  'robot steals venom from tied target
                .mem(825) = .venom
              End If
              If Not .Ties(k).back Then   'forward ties
                .Ties(k).nrgused = True   'red ties
              Else                        'backward ties
                rob(.Ties(k).pnt).Ties(.Ties(k).ptt).nrgused = True 'red ties
              End If
            End If
            k = k + 1
          Wend
        End If
        If .mem(tp + 2) = -4 And .mem(tp + 3) <> 0 Then 'trade waste via ties
          If .mem(tp + 3) > 1000 Then .mem(tp + 3) = 1000
          If .mem(tp + 3) > .Waste Then .mem(tp + 3) = .Waste
          If .mem(tp + 3) < -1000 Then .mem(tp + 3) = -1000
          k = 1
          While .Ties(k).pnt > 0
            If .Ties(k).Port = tn Then
              'If .mem(tp + 3) < rob(.Ties(k).pnt).Waste Then .mem(tp + 3) = rob(.Ties(k).pnt).Waste
              If .mem(tp + 3) > 0 Then
                rob(.Ties(k).pnt).Waste = rob(.Ties(k).pnt).Waste + .mem(tp + 3)
                .Waste = .Waste - .mem(tp + 3)
                .Pwaste = .Pwaste + (.mem(tp + 3) / 1000)
              Else
                rob(.Ties(k).pnt).Waste = rob(.Ties(k).pnt).Waste + .mem(tp + 3)
                .Waste = .Waste - .mem(tp + 3)  'robot steals waste from tied target
                rob(.Ties(k).pnt).Pwaste = rob(.Ties(k).pnt).Pwaste - .mem(tp + 3)
              End If
              If Not .Ties(k).back Then   'forward ties
                .Ties(k).nrgused = True   'red ties
              Else                        'backward ties
                rob(.Ties(k).pnt).Ties(.Ties(k).ptt).nrgused = True 'red ties
              End If
            End If
            k = k + 1
          Wend
        End If
        
        .mem(tp + 2) = 0
        .mem(tp + 3) = 0
      End If
    End If
    '.mem(tp + 5) = 0
    
  End With
End Sub
Public Sub readtie(t As Integer)
'reads all of the tref variables from a given tie number
  Dim k As Integer
  Dim l As Integer
  Dim tn As Integer
  k = 1
  With rob(t)
    tn = .mem(471)
    While .Ties(k).pnt > 0
      If .Ties(k).Port = tn Then
        If rob(.Ties(k).pnt).nrg < 32000 Then
          .mem(464) = rob(.Ties(k).pnt).nrg 'copies tied robot's energy into memory cell *trefnrg
        End If
        If rob(.Ties(k).pnt).age < 32000 Then
          .mem(465) = rob(.Ties(k).pnt).age + 1 'copies age of tied robot into *refvar
        Else
          .mem(465) = 32000
        End If
        If rob(.Ties(k).pnt).body < 32000 Then
          .mem(472) = rob(.Ties(k).pnt).body  'copies tied robot's body value
        Else
          .mem(472) = 32000
        End If
        For l = 1 To 8    'copies all ref vars from tied robot
          .mem(455 + l) = rob(.Ties(k).pnt).occurr(l)
        Next l
        If .mem(476) > 0 Then  'tmemval and tmemloc couple used to read a specific memory value from tied robot.
          .mem(475) = rob(.Ties(k).pnt).mem(.mem(476))
          .mem(476) = 0
        End If
        If rob(.Ties(k).pnt).Fixed Then
          .mem(478) = 1
        Else
          .mem(478) = 0
        End If
        .mem(479) = rob(.Ties(k).pnt).aim
        .mem(trefxpos) = rob(.Ties(k).pnt).mem(219)
        .mem(trefypos) = rob(.Ties(k).pnt).mem(217)
        .mem(trefvelyourup) = rob(.Ties(k).pnt).mem(velup)
        .mem(trefvelyourdn) = rob(.Ties(k).pnt).mem(veldn)
        .mem(trefvelyoursx) = rob(.Ties(k).pnt).mem(velsx)
        .mem(trefvelyourdx) = rob(.Ties(k).pnt).mem(veldx)
                
        .mem(trefvelmyup) = rob(.Ties(k).pnt).vx * Cos(.aim) + Sin(.aim) * rob(.Ties(k).pnt).vy * -1 - .mem(velup) 'gives velocity from mybots frame of reference
        .mem(trefvelmydn) = .mem(trefvelmyup) * -1
        .mem(trefvelmydx) = rob(.Ties(k).pnt).vy * Cos(.aim) + Sin(.aim) * rob(.Ties(k).pnt).vx - .mem(veldx)
        .mem(trefvelmysx) = .mem(trefvelmydx) * -1
        .mem(trefvelscalar) = rob(.Ties(k).pnt).mem(velscalar)
        .mem(trefbody) = rob(.Ties(k).pnt).body
        .mem(trefshell) = rob(.Ties(k).pnt).Shell
      End If
      
      k = k + 1
    Wend
  End With
End Sub

' deletes all ties of a robot a
Public Sub delallties(a As Integer)
  While rob(a).Ties(1).pnt > 0
    deltie a, rob(a).Ties(1).pnt
  Wend
End Sub

' deletes a tie between robots a and b
Public Sub deltie(ByVal a As Integer, ByVal b As Integer)
  Dim k As Integer
  Dim j As Integer
  Dim t As Integer
  k = 1
  j = 1
  While rob(a).Ties(k).pnt <> b And k < 6
    k = k + 1
  Wend
  While rob(b).Ties(j).pnt <> a And j < 6
    j = j + 1
  Wend
  If k < 6 Then
    For t = k To 9
      rob(a).Ties(t) = rob(a).Ties(t + 1)
    Next t
  End If
  If j < 6 Then
    For t = j To 9
      rob(b).Ties(t) = rob(b).Ties(t + 1)
    Next t
  End If
End Sub

'
' T I E S
'

' creates a tie between rob a and b,of len c, lasting last cycles
' (or waiting -last cycles before consolidating)
' tie is addressed with index mem (putting mem in .tienum)
Public Sub maketie(a As Integer, b As Integer, c As Long, last As Integer, mem As Integer)
  Dim k As Integer
  Dim j As Integer
  Dim ok As Boolean
  Dim Mx As Integer
  Dim deflect As Integer
  Dim length As Long
  If rob(b).Corpse = True Or rob(a).Corpse = True Then Exit Sub
  deflect = Int(Rnd * 90) + 2  'random number which allows for the effect of slime on the target robot. If slime is greater then no tie is formed
  Mx = 5
  ok = True
  k = 1
  j = 1
  
  length = Sqr((rob(a).x - rob(b).x) ^ 2 + (rob(a).Y - rob(b).Y) ^ 2)
  If length <= c * 1.5 Then 'And deflect > rob(b).slime Then
    If deflect < rob(b).Slime Then ok = False  'should stop ties forming when slime is high
    While rob(a).Ties(k).pnt > 0 And k < Mx And ok
      If rob(a).Ties(k).pnt = b And rob(a).Ties(k).last < 0 Then ok = False
      k = k + 1
    Wend
    While rob(b).Ties(j).pnt > 0 And j < Mx And ok
      j = j + 1
    Wend
    If k < Mx And j < Mx And ok Then
      rob(a).Ties(k).pnt = b
      rob(a).Ties(k).ptt = j
      rob(a).Ties(k).ln = c
      rob(a).Ties(k).stat = False
      rob(a).Ties(k).last = last
      rob(a).Ties(k).Port = mem
      rob(a).Ties(k).back = False
      rob(a).Numties = rob(a).Numties + 1
      rob(b).Ties(j).pnt = a
      rob(b).Ties(j).ptt = k
      rob(b).Ties(j).ln = c
      rob(b).Ties(j).stat = False
      rob(b).Ties(j).last = last
      rob(b).Ties(j).Port = mem
      rob(b).Ties(j).back = True
      rob(b).Numties = rob(b).Numties + 1
    End If
  End If
  If rob(b).Slime > 0 Then rob(b).Slime = rob(b).Slime - 20: If rob(b).Slime < 0 Then rob(b).Slime = 0 'cost to slime layer when attacked
  rob(a).nrg = rob(a).nrg - SimOpts.CostChem / (rob(a).Numties + 1) 'Chemical emision cost to form tie
End Sub

' searches a tie in rob t pointing to rob p
' returns tie number (j) of the tie pointing to the specified robot
Public Function srctie(t As Integer, p As Integer) As Integer
  Dim j As Integer
  j = 1
  srctie = 0
  With rob(t)
  While .Ties(j).pnt > 0 And srctie = 0
    If .Ties(j).pnt = p And .Ties(j).last < 1 Then
      srctie = j
    End If
    j = j + 1
  Wend
  End With
End Function

' fixes tie angle and length at whatever it currently is
Public Sub regang(t As Integer, j As Integer)
  Dim n As Integer
  Dim angl As Single
  Dim dist As Long
  With rob(t)
      .Multibot = True: .mem(470) = 1
      n = .Ties(j).pnt
      angl = angle(.x, .Y, rob(n).x, rob(n).Y)
      dist = Sqr((.x - rob(n).x) ^ 2 + (.Y - rob(n).Y) ^ 2)
      .Ties(j).ang = AngDiff(angl, rob(t).aim)
      .Ties(j).ln = dist: If .Ties(j).ln < 200 Then .Ties(j).ln = 200
      If .mem(468) <> 32000 And .mem(468) <> 0 Then          'replaces .ang calculated value with .fixang value
        If .mem(468) > 628 Then .mem(468) = 628
        If .mem(468) < -628 Then .mem(468) = -628
        .Ties(j).ang = .mem(468) / 200 'should it be 100 or 200?
      End If
      If .mem(469) <> 0 Then            'replaces .ln with .fixlen value
       .Ties(j).ln = .mem(469)
      End If
      .Ties(j).angreg = True
      '.mem(10) = .Ties(j).ang       'temporary test locations
      '.mem(11) = .Ties(j).ln
  End With
End Sub

' bends a tie
Public Sub bend(t As Integer, lnk As Integer, ang As Integer)
  Dim an As Single
  If Abs(ang) > 100 Then ang = 100 * Sgn(ang)
  an = ang / 100
  With rob(t).Ties(lnk)
    .bend = an
    rob(.pnt).Ties(.ptt).bend = -an
  End With
  ang = 0
End Sub

' shrinks a tie
Public Sub shrink(t As Integer, lnk As Integer, ln As Integer)
  If Abs(ln) > 100 Then ln = 100 * Sgn(ln)
  With rob(t).Ties(lnk)
    .shrink = ln
    rob(.pnt).Ties(.ptt).shrink = ln
  End With
  ln = 0
End Sub
